Subject: bug#41602: texlive-texmf is actually subtitutable

From: Maxim Cournoyer <[email-masked]>
Date: Tue, 02 Apr 2024 22:09:26 -0400

Hello,

Ludovic Courtès <[email-masked]> writes:

> Hi,
>
> Leo Famulari <[email-masked]> skribis:
>
>> On Fri, May 29, 2020 at 05:15:40PM +0200, Ludovic Courtès wrote:
>>> The info suggests it won’t be substituted, but it’s eventually
>>> substituted.  I wonder why, because the .drv has:
>>> 
>>>   ("allowSubstitutes","0")
>>> 
>>> and the daemon has:
>>> 
>>>   bool substitutesAllowed(const Derivation & drv)
>>>   {
>>>       return get(drv.env, "allowSubstitutes", "1") == "1";
>>>   }
>>> 
>>> and:
>>> 
>>>   if (settings.useSubstitutes && substitutesAllowed(drv))
>>>       foreach (PathSet::iterator, i, invalidOutputs)
>>>           addWaitee(worker.makeSubstitutionGoal(*i, buildMode == bmRepair));
>>> 
>>> Thoughts?
>>
>> I wonder if the content-addressed fallbacks take a different code path
>> that doesn't respect "allowSubstitutes"?
>
> It does, but this texlive-texmf.drv is not a fixed-output derivation.

I just verified; this still happens:

--8<---------------cut here---------------start------------->8---
$ guix build texlive -n
substitute: mise à jour des substituts depuis « https://ci.guix.gnu.org »... 100.0 %
La dérivation suivante serait compilée :
  /gnu/store/ym96pipknrh6khzc3ws8ychiy6224y61-texlivetexmf-20230313.drv
3 880,6 Mo seraient téléchargés :
  /gnu/store/rzczwmmkvpkahy0mgpahav0yx37ci61b-texlive-20230313-texmf.tar.xz
  /gnu/store/bcc5071mvprhp4yj1jimlhyyi499d2ba-texlivebin-20230313
  /gnu/store/bd4mzanvv7q2plm2b6zld8cz3fy0x34a-texlive-20230313
maxim@hurd ~/src/guix [env]$ guix build /gnu/store/bd4mzanvv7q2plm2b6zld8cz3fy0x34a-texlive-20230313
substitute: mise à jour des substituts depuis « https://ci.guix.gnu.org »... 100.0 %
substitution de /gnu/store/bcc5071mvprhp4yj1jimlhyyi499d2ba-texlivebin-20230313...
téléchargement depuis https://ci.guix.gnu.org/nar/lzip/bcc5071mvprhp4yj1jimlhyyi499d2ba-texlivebin-20230313...
 texlivebin-20230313  13.5MiB                                   527KiB/s 00:26 ▕██████████████████▏ 100.0%

substitution de /gnu/store/4hr3i6p7g2miwhy9gn64mxp1haix36dq-texlivetexmf-20230313...
téléchargement depuis https://ci.guix.gnu.org/nar/lzip/4hr3i6p7g2miwhy9gn64mxp1haix36dq-texlivetexmf-20230313...
 texlivetexmf-20230313  3.63GiB                                 360KiB/s 00:17 ▕                  ▏   0.2%^C
--8<---------------cut here---------------end--------------->8---

-- 
Thanks,
Maxim